<?php
// Подключение ядра Друпала для использования его функций
setlocale(LC_ALL, 'ru_RU.UTF-8');
define('DRUPAL_ROOT', '/home/zalman/localserver/bellagio.loc/public_html');
$_SERVER['REMOTE_ADDR'] = "localhost";
require_once DRUPAL_ROOT . '/includes/bootstrap.inc';
drupal_bootstrap(DRUPAL_BOOTSTRAP_FULL);
// Подключение библиотеки QueryPath
require DRUPAL_ROOT . '/QueryPath/QueryPath.php';
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset='utf-8'>
    <title>Parser</title>
</head>
<body>
<h1>Парсер</h1>
<?php

// Построчный парсинг txt файла
$array = file("urls.txt");
foreach ($array as $key => $value):
    $url = trim($value);

    // Парсинг документа по ссылке с помощью QueryPath
    $table = htmlqp($url, '.lay1 .table');
    $title = htmlqp($url, 'h1');

    $arr_tr = array();
    foreach ($table->find('tr') as $tr) {

        $desc = $tr->find('td:first-child span')->text();

        $first_td = $tr->parent('td');
        $first_td->remove('span');
        $title = $first_td->text();

        $price = str_replace(' руб.', '', $tr->parent('tr')->find('td:eq(3)')->text());

        $mera = $tr->parent('tr')->find('td:eq(2)')->text();

        $arr_tr[] = array(
            'name' => $title,
            'desc' => $desc,
            'price' => $price,
            'mera' => $mera
        );
    }

    // Создаём объект ноды
    $node = new stdClass();
    $node->type = "menu"; // Указываем тип материала
    $node->title = $title; // Заголовок ноды
    $node->language = 'ru';
    node_object_prepare($node); // Функция подготовки ноды
    $node->uid = 1; // автор ноды - админ

    // Инструкция по добавлению разных типов полей:
    // http://timonweb.com/posts/how-to-programmatically-create-nodes-comments-and-taxonomies-in-drupal-7/

    // Добавляем коллекцию полей в цикле
    foreach ($arr_tr as $tr) {
        $field_collection_item = entity_create('field_collection_item', array('field_name' => 'field_meals'));
        $field_collection_item->setHostEntity('node', $node);
        $field_collection_item->field_name_meals['und'][]['value'] = $tr['name'];
        $field_collection_item->field_description['und'][]['value'] = $tr['desc'];
        $field_collection_item->field_amount['und'][]['value'] = $tr['mera'];
        $field_collection_item->field_price_meals['und'][]['value'] = $tr['price'];
        $field_collection_item->save(TRUE);
    }

    $node = node_submit($node); // Подготавливаем ноды к сохранению
    //node_save($node); // Сохраняем ноду


endforeach;

?>
</body>
</html>
